	org	$00000000

startsp		equ	$0001FFFE

zx83base	equ	$00018000
ramstart	equ	$00020000
basramsiz	equ	$0001FFFF

	dc.l	startsp
	dc.l	start
	dc.l	buserr
	dc.l	addresserr
	dc.l	illegalins
	dc.l	divzero
	dc.l	chkerr
	dc.l	trapv
	dc.l	privviol
	dc.l	trace
	dc.l	linea
	dc.l	linef
	dc.l	$00000000
	dc.l	$00000000
	dc.l	$00000000
	dc.l	unintvec
	dc.l	$00000000
	dc.l	$00000000
	dc.l	$00000000
	dc.l	$00000000
	dc.l	$00000000
	dc.l	$00000000
	dc.l	$00000000
	dc.l	$00000000
	dc.l	spurint
	dc.l	intvec1
	dc.l	intvec2
	dc.l	intvec3
	dc.l	intvec4
	dc.l	intvec5
	dc.l	intvec6
	dc.l	intvec7
	dc.l	trapvec
	
	org	$00000400

start:
	lea	zx83base,a0
	move.b	#0,$63(a0)	; Change to MODE 4
	move.b	#$0F,$21(a0)	; Clear and disable interrupts
	move.b	#$05,$2(a0)	; Set the ouput serial port settings (ser1, 4800 baud)
	lea	bannertext,a1	; Put the address of the text banner into a1
printban:
	cmpi.b	#0,(a1)		; Is it a NULL byte?
	beq	banend		; If so finish
	move.b	(a1)+,d0	; Copy character into d0 and increment a1
	move.b	d0,$22(a0)	; Transmit the character.
banprtwait:
	btst.b	#2,$20(a0)	; See if the transmit buffer is full
	bne	banprtwait	; If it is go around again until it's empty
	bra	printban	; Print the next character
banend:
	bra	memtest		; Test the memory.
endmemtst:
	stop #$2700		; Stop execution at the moment. We're in a state where we have working memory and can continue.
	
memtest:
	move.l	#basramsiz,d0	; Put the base RAM size into d0
	lea	ramstart,a1	; Load the base of RAM into a1
marchtestp1:
	move.b	#$FF,(a1)+	; Write a byte of 1s to RAM.
	dbne	d0,marchtestp1	; Go around until all RAM has been filled.

	move.l	#basramsiz,d0	; Put the base RAM size into d0
	lea	ramstart,a1	; Load the base of RAM into a1
	moveq	#-1,d1
marchtestp2:
	cmpi	#$FF,(a1)	; Test if what we read is what we wrote.
	bne	memerror	; If it's not error and halt.
	eor	d1,(a1)+	; XOR the memory value with all ones.
	dbne	d0,marchtestp2	; Go around again until all memory has been done.

	move.l	#basramsiz,d0	; Put the base RAM size into d0
	lea	ramstart,a1	; Load the base of RAM into a1
marchtestp3:
	cmpi	#$00,(a1)	; Test if what we read is the opposite of what we wrote.
	bne	memerror	; If it's not error and halt.
	eor	d1,(a1)+	; XOR the memory value with all ones.
	dbne	d0,marchtestp3	; Go around again until all memory has been done.

	move.l	#basramsiz,d0	; Put the base RAM size into d0
	lea	ramstart,a1	; Load the base of RAM into a1
marchtestp4:
	cmpi	#$FF,(a1)	; Test if what we read is what we wrote originally.
	bne	memerror	; If it's not error and halt.
	eor	d1,(a1)+	; XOR the memory value with all ones.
	dbne	d0,marchtestp4	; Go around again until all memory has been done.

	bra	endmemtst	; The memory test has completed successfully.

memerror:
	lea	memerrtext,a1	; Put the address of the memory error text into a1
printmemerr:
	cmpi.b	#0,(a1)		; Is it a NULL byte?
	beq	memerrtxtend		; If so finish
	move.b	(a1)+,d0	; Copy character into d0 and increment a1
	move.b	d0,$22(a0)	; Transmit the character.
memerrprtwait:
	btst.b	#2,$20(a0)	; See if the transmit buffer is full
	bne	memerrprtwait	; If it is go around again until it's empty
	bra	printmemerr	; Print the next character
memerrtxtend:
	stop #$2700

buserr:
addresserr:
illegalins:
divzero:
chkerr:
trapv:
privviol:
trace:
linea:
linef:
unintvec:
spurint:
intvec1:
intvec2:
intvec3:
intvec4:
intvec5:
intvec6:
intvec7:
trapvec:
	stop #$2700

bannertext:
	dc.b	"QL Diagnostics version 0.00",$0d,$0a,$0
memerrtext:
	dc.b	"Memory test error, halting.",$0d,$0a,$0

align
